//jQuery.noConflict();
//alert(jQuery.noConflict());

/* Public Variable 
 *
 */
var oTextRange;
var oElement;
var vBrowser = getBrowser();
var oCurrentTag;


(function($) {
/**
 * L10N Parsing laverage by jQuery. 
 * <div class="l10n"></div> 
 * $('.l10n').L10N();
 * @param {String} options The options to pass into function
 */
    $.fn.L10N = function(options) {
        var opts = $.extend({}, $.fn.L10N.defaults, options);
        return this.each(function() {
          $this = $(this);
          // The L10N would be defined in localization.js or other l10n files
          $this.html(   L10N.GLOBAL[$this.attr('rel')] ||
                        opts.src[$this.attr('rel')] || $this.attr('rel'));
                        /*$this.attr('rel').replace('_',' ')*/ 
        });
    };
    $.fn.L10N.defaults = {src:{}};
})(jQuery);

/* jsInsertString: Insert string from localization.js to specified element
 * 
 */
function jsInsertString(trgID,strMsg,strValue) {
	var eleType = document.getElementById(trgID).tagName;
	switch(eleType) {
		case "INPUT":
			if(strMsg.length > 6) {
				document.getElementById(trgID).style.width = "auto";
			}
			document.getElementById(trgID).value = strMsg;
			
			break;
		case "SELECT":
			jsSelectOption(trgID,strMsg,strValue);
			break;
		default:
			document.getElementById(trgID).innerHTML = strMsg;
			break;
	}
}


/* focusDefaultButton: set focused button
 * 
 */ 
function focusDefaultButton(oBtnId) {
	$("#" + oBtnId).focus();
	$("#" + oBtnId).addClass("btn_default_focus");
}


function setFocus(oTarget) {
	if(oTarget.disabled==false)
	{
		oTarget.focus();
		oTarget.select();
	}
}


function getBrowser() {
	var sTemp = "IE";
	if (navigator.appName != "Microsoft Internet Explorer") { sTemp = "NN"; }
	return sTemp;	
}


/* setUIDisplay: set the UI range display or not
 * [srcState] true/false
 * [tarObj] the target object
 */
function setUIDisplay(srcState,tarObj){
	if (tarObj == null) return;
	tarObj.style.display = (srcState)?"":"none";
}


/* setUIMoreDisplay_IMG: set the More range display or not and change the images
 * [tarObj] the target object
 */
function setUIMoreDisplay_IMG(tarObj){
	if (tarObj == null) return;
	var bFlag = (tarObj.src.search("plus") > -1)?true:false;
	if (vBrowser=="IE") { // Only for IE browser
		if (document.all(tarObj.id + "_items").length == null) {
			setUIDisplay(bFlag,document.all(tarObj.id + "_items"));
		} else {
			for (var i=0;i<document.all(tarObj.id + "_items").length;i++)
				setUIDisplay(bFlag,document.all(tarObj.id + "_items")[i]);
		}
	} else {
		setUIDisplay(bFlag,document.getElementById(tarObj.id + "_items"));
		
	}
	if (bFlag){
		tarObj.src = tarObj.src.replace("plus","minus");
	} else {
		tarObj.src = tarObj.src.replace("minus","plus");
	}
	tarObj.blur();
}


/* setDynamicUIMoreDisplay_IMG: set the More range display or not and change the images
 */
function setDynamicUIMoreDisplay_IMG(){
	//if (tarObj == null) return;
	tarObj = this;
	var bFlag = (tarObj.src.search("plus") > -1)?true:false;
	if (vBrowser=="IE") { // Only for IE browser
		if (document.all(tarObj.id + "_items").length == null) {
			setUIDisplay(bFlag,document.all(tarObj.id + "_items"));
		} else {
			for (var i=0;i<document.all(tarObj.id + "_items").length;i++)
				setUIDisplay(bFlag,document.all(tarObj.id + "_items")[i]);
		}
	} else {
		setUIDisplay(bFlag,document.getElementById(tarObj.id + "_items"));
		
	}
	if (bFlag){
		tarObj.src = tarObj.src.replace("plus","minus");
	} else {
		tarObj.src = tarObj.src.replace("minus","plus");
	}
	tarObj.blur();
}


/* setUIChecked:
 *
 */
function setUIChecked(srcState, tarObj){
	if (tarObj) {
		if (tarObj.length == null) {
			if (tarObj.checked!=srcState) {
				tarObj.click();
			}
		} else {
			for (var i=0;i<tarObj.length;i++) {
				if (tarObj[i].checked!=srcState) {
					tarObj[i].click();
				}
			}
		}
	}
}


/* setUIItemsChecked:
 *
 */
function setUIItemsChecked(oAll,oItems,bFlag) {
	if (oAll == null) { return; }
	if (oItems == null) { return; }
	
	if (vBrowser=="IE") oAll.style.filter = "";
	if (vBrowser=="NN") oAll.style.backgroundColor = "";
	if (oItems.length == null) {
		oAll.checked = oItems.checked;
	} else {
		var nCount = getUIItemsChecked(oItems);
	    if (bFlag) {	// oAll will be un-checked, when there is more than one item which was un-checked.
			oAll.checked = (nCount == oItems.length) ? 1 : 0;
		} else {		// oAll will be un-checked, when all items were un-checked.
			oAll.checked = (nCount > 0) ? 1 : 0;
			if (nCount > 0 && nCount < oItems.length) {
				if (vBrowser=="IE") oAll.style.filter = "progid:DXImageTransform.Microsoft.Wave(Add='false', LightStrength=30, Phase=60, Strength=0, Freq=20)";
				if (vBrowser=="NN") oAll.style.backgroundColor = "#bbbbbb";
			}
		}
  	}
}


/* getUIItemsChecked:
 * re-wrote by Jeff (buggy in Firefox)
 */
function getUIItemsChecked(oItems) {
	if (!oItems) { return 0; }
	if (oItems.length == null ) {
		return oItems.checked ? 1 : 0;
	} else {
		var nCount = 0;
		for(var i=0;i<oItems.length;i++) {
			if(!oItems[i].checked) { continue;}
			nCount ++;
		}
		return nCount;
	}
}

/* showHideTooltip:
 * icon_id: tooltip icon; info_id:tooltip content
 */
function showHideTooltip(icon_id, info_id) {
	$("#" + icon_id).hover(
        function () {
			//alert($("#" + info_id));
			$("#" + info_id).show();
        },function(){
			$("#" + info_id).hide();
	});
}


/* showHideContent:
 * hide_id: click to hide; show_id: click to show;  show_id_content: the content
 */
function showHideContent(hide_id, show_id, show_id_content){
	$("#" + show_id).click(function () {
		$("#" + show_id_content).show();
	});
	$("#" + hide_id).click(function () {
		$("#" + show_id_content).hide();
	});
}


/* closeWin:
 * close window
 */
function closeWin(){
	window.close();	
}


/* MM_openBrWindow:
 * open popup window
 */
function MM_openBrWindow(theURL,winName,features) { //v2.0
  window.open(theURL,winName,features);
}


/* changeFqcy:
 * change frenquency
 */
function changeFqcy(fqcy){
	document.getElementById("fqcy0").style.display = (fqcy == "fqcy0") ? "" : "none";
	document.getElementById("fqcy1").style.display = (fqcy == "fqcy1") ? "" : "none";
	document.getElementById("fqcy2").style.display = (fqcy == "fqcy2") ? "" : "none";
}



function jsOpenHelp(sURL) {
	// init variant
	var iSpam = jsGetiSpamValue("enableSpam");
	
	var sBase = (iSpam ==1)?"../i18n/en_US/html/online_help/CSM_Security_for_SMB/":"../i18n/en_US/html/online_help/CS_Security_for_SMB/";
	var sName = "CSM_HELP";
	
	sURL = sBase + sURL;
	var rv = window.open(sURL,sName,"toolbar=no,menubar=no,directories=no,scrollbars=yes,resizable=yes,dependent=yes");
	rv.opener = self;
	
	// resize window
	rv.resizeTo((screen.availWidth*6)/10+1, screen.availHeight);
	rv.moveTo((screen.availWidth*4)/10, 0);
	rv.focus();
}

function jsGetiSpamValue(cName)
{
    var CookieString = " "+document.cookie+";";
    var Look4Name = " "+cName+"=";
    var Index = CookieString.indexOf(Look4Name);
    if ( Index!=-1 )
    {
        Index = Index+Look4Name.length;
        var IndexEnd = CookieString.indexOf(";", Index);
        return  parseInt(CookieString.substring(Index, IndexEnd), 10);
    }
    return  0;
}


