/************************************************************
  Tooltip 
  Usage: $('.tip').tooltip(); 
  <q class="tip" rel="title" desc="content"></q>
*************************************************************/
    $.fn.tooltip = function (options) {   
        var opts = $.extend({
            tip_id: 'tooltip',  // ID of tooltip tag
            w: '200px',          // default width of tooltip
            fading_time: 300,   // how long the tooltip will hide
            iframe_id: 'tipFrame', // used in IE6 and below
            // offset the content for showing tooltip icon
			hideHeader:	false, // hide h5 element or not
            icon_x:14,
			icon_y:14
        }, options);
        
        if($('#'+opts.tip_id).length==0) {
            var $tip = $('<div id="'+ opts.tip_id +'"></div>').appendTo(document.body).append('<h5></h5><p></p>');
        } else {
            var $tip = $('#'+opts.tip_id);
        }
        $tip.hover( 
            function(){ $(this).data('showing','1');} ,
            function(){  
                $tip.data('showing','0');
                return setTimeout(function(){
                    hideTip();
                }, opts.fading_time);
            } 
        );
        
        function hideTip(){
            if($tip.data('showing')!='1'){
                $tip.css('left','-10000px');
                if(opts.useIframe) {
                    $('#'+opts.iframe_id).css('left','-10000px');
                }
            }
        }
        
        function tipFrame() {
            var fr = $('#'+opts.iframe_id);
            if(fr.length==0) {
                fr = $('<iframe src="empty.htm"></iframe>').insertBefore($tip).attr('id',opts.iframe_id);
            }
            fr.css({
                position:'absolute',
                width : $tip.width() +2+ 'px',
                height: $tip.height()+2+ 'px',
                left  : $tip.css('left'),
                top   : $tip.css('top') ,
                zIndex: 0
            });
            
        }
        
        return this.each(function() {
            $(this).hover( 
            //mouseover
                function() {
                    var ofs = $(this).offset();
                    $tip.data('showing','1')
                    .css({ 
                        top  : ofs.top +opts.icon_y + 'px', 
                        left : ofs.left+opts.icon_x + 'px' , 
                        zIndex:2,
                        width: $(this).attr('tip_width') ? $(this).attr('tip_width') : opts.w
                    })
                    .find('h5').text($(this).attr('rel'))
                    .next('p').html($(this).attr('desc'));
					
					if (opts.hideHeader) {
						$tip.find('h5').hide();
					}
					
                    var w_win = (window.innerWidth ||document.documentElement.clientWidth);
                    var h_win = (window.innerHeight||document.documentElement.clientHeight);
                    
                    $tip.css({
                        top : ($tip.offset().top+$tip.height()+opts.icon_y)<h_win ? ofs.top+opts.icon_y+'px':  (ofs.top -$tip.height()) +'px',
                        left: ($tip.offset().left+$tip.width()+opts.icon_x)<w_win ? ofs.left+opts.icon_x+'px': (ofs.left-$tip.width())  +'px'
                    });
                    
                    if($.browser.msie && parseInt($.browser.version,10)<=6){
                        opts.useIframe = true;
                        tipFrame();
                    }
                },
                
            //mouseout
                function() {
                    $tip.data('showing','0');
                    return setTimeout(function(){
                        hideTip();
                    }, opts.fading_time);
                }
            );
        });
    }